#include <18f26k22.h>
#device ADC=10
#include <string.h>
#include <stdlib.h>
#fuses INTRC_IO,NOWDT,NOLVP,NOMCLR,PROTECT,NOBROWNOUT
#use delay(CLOCK=64MHz)
#use rs232(baud=19200,xmit=PIN_C6,rcv=PIN_C7,parity=N,bits=8,stream=c1,ERRORS)//main connect.
//#use rs232(baud=19200,xmit=PIN_B6,rcv=PIN_B7,parity=N,bits=8,stream=c2,ERRORS)//
#use i2c(MASTER, SDA=PIN_C4, SCL=PIN_C3,SLOW,FORCE_HW)//FAST=400kbps SLOW=100kbps

//#include "am2321.c"//xExZT[
//#include "aqmxx02a.c"//LN^LCDW[
#include "so1602awxb.c"//L@ELLN^W[
//#include "tc74hc595.c"//o̓WbNIC
//#include "sw_process.c"//XCb`
//#include "tc74hc165.c"//̓WbNIC
#include "ws2812b.c"//VAʐMLED ws2812

//ϐ蓖
//VA֌W
int get_command_value_c1 = 0;
int get_command_value_c2 = 0;
char get_command_c1[80] = {
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};//MR}hɂ킹
char get_command_c2[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char compare_command_c1[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
//char compare_command_c2[10] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
char punctuate[] = ",";//VA̋̕؂
//tbJ[֌W
int flicker_hi = 0;
int flicker_hi_one = 0;
int flicker_middle = 0;
int flicker_middle_one = 0;
int flicker_low = 0;
int flicker_low_one = 0;
int output_process_one = 0;
long counttimer1 = 0;
long counttimer2 = 0;
long counttimer3 = 0;
long counttimer4 = 0;
//AiOv֌W
long analog_value = 0;

//̑
int32 test_val = 0;
//int set_val = 0;
long main_step = 0;//CXebv
int port1_ra1 = 0;

//֐錾
void startup();
void serial_process1();
void serial_process2();
void output_process();
void input_process();

//VÅ荞
#int_rda
void isr_rcv(){
	while(kbhit(c1)){  // }CR̎Mobt@̃f[^SĎM
		get_command_c1[get_command_value_c1] = fgetc(c1);//Mf[^o
		fprintf(c1,"%c",get_command_c1[get_command_value_c1]);
		get_command_value_c1++;//CfbNX{P
	}
}

#int_timer0
void int_timer(){
	//4msec

	//^C}[lZbg
	//set_timer0(0xffff);//
	//set_timer0(0x0000);//64MHz̎
	//set_timer0(0x07);//32MHz̎

	//AiOl擾
	//analog_value = read_adc()*4;
	//set_adc_channel(0);
	
	if(counttimer1 > 11){
		//49msecPʂ̎s

		//JE^[Zbg
		counttimer1 = 0;

		flicker_hi = !flicker_hi;
		flicker_hi_one = 1;
	}
	counttimer1++;

	if(counttimer2 > 24){
		//100msecPʂ̎s
		
		//JE^[Zbg
		counttimer2 = 0;

		flicker_middle = !flicker_middle;
		flicker_middle_one = 1;
	}
	counttimer2++;

	if(counttimer3 > 121){
		//500msecPʂ̎s
		
		//JE^[Zbg
		counttimer3 = 0;
		
		flicker_low = !flicker_low;
		flicker_low_one = 1;

		//xExv
		//QɂP̊Ōv
		//am2321_read();
	}
	counttimer3++;
	counttimer4++;
}



//X^[gAbv
void startup(){
	int tmp1 = 0;
	//int tmp2 = 0;

	//NbNݒ
	setup_oscillator(OSC_16MHZ|OSC_PLL_ON);

	setup_timer_0(RTCC_INTERNAL | RTCC_DIV_1 );//
	//setup_timer_0(RTCC_INTERNAL | RTCC_DIV_16 );//
	enable_interrupts(INT_TIMER0); //^C}荞݋
	enable_interrupts(INT_RDA); //VA荞݋
	enable_interrupts(GLOBAL); //S荞݋

	//AiO|[g̐ݒ
	//setup_vref(VREF_ON|VREF_ADC_4v096);
	setup_adc(ADC_CLOCK_INTERNAL);
	setup_adc_ports(sAN0,VSS_FVR);

	//|[gݒ 0:OUT 1:IN
	set_tris_a(0b00000000);
	set_tris_b(0b00000000);
	set_tris_c(0b10011111);

	////ݒlǂݍ
	////\[h
	//mode = READ_EEPROM(0x00);
	//if(mode == 0xff){
	//	mode = 0;
	//}else if(mode == 0x01){
	//	set_mode = 1;
	//}

	//dAeW[N̂҂
	delay_ms(200);

	//L@ELLN^W[̏
	//so1602awxb_init();

	////L@ELLN^W[\
	////Psڕ\
	//so1602awxb_cmd(0x80);
	//so1602awxb_puts("ZEATEC co.,ltd. ");
	////Qsڕ\
	//so1602awxb_cmd(0xa0);
	//printf(so1602awxb_puts,	")ްï        ");

	////LCD̏
	////delay܂܂Ă̂ŃX^[gAbvȊOŎgpȂ
	//LCD_CreateChar(1,aqmxx02a_icon_1);//IWiLN^o^
	//LCD_CreateChar(2,aqmxx02a_icon_2);//IWiLN^o^

	////RgXĝߎgpdw@3 = 3.3V 5 = 5V
	////delay܂܂Ă̂ŃX^[gAbvȊOŎgpȂ
	//aqmxx02a_init(3) ;

	//aqmxx02a_setcursor(0,0);        // \ʒuݒ肷
	//aqmxx02a_puts(")ްï");
	//aqmxx02a_setcursor(0,1);        // \ʒuݒ肷
	//aqmxx02a_puts(" ZEATEC co.,ltd.");

	//\Fpӂ
	ws2812_color_set();
	ws2812_process();//Pڂ͎sm̂ł炩߂P񑗂B

}

//C
void main(){

	//X^[gAbv
	startup();

	while(true){

		//WbNIC擾
		//test_val = tc74hc165();

		//͏
		input_process();

		if(flicker_hi_one == 1){
			//flicker_low_one = 0;
			//flicker_middle_one = 0;
			flicker_hi_one = 0;

			if(ws2812_step==ws2812_step_max){
				ws2812_step=0;
			}else{
				ws2812_step++;
			}

			ws2812_process();

		}

		//WbNICo
		//tc74hc595(test_val);

		//VA|[g̃R}h
		serial_process1();

		//o͏
		output_process();

	}
}

//̓|[g擾
void input_process(){
	//if(input(PIN_A1)==1){
	//	//ON̎
	//	port1_ra1 = 1;
	//}else{
	//	//OFF̎
	//	port1_ra1 = 0;
	//}

}

//o̓|[g
void output_process(){

	int tmp1 = 0;

	//LED\(8)
	//LEDo͔͂]邱	

	//PORT1
	//output_bit(PIN_A0,!flicker_middle);
	//output_bit(PIN_A1,!flicker_middle);
	output_bit(PIN_A2,!flicker_hi);
	output_bit(PIN_A3,!flicker_hi);
	output_bit(PIN_A4,!flicker_hi);
	output_bit(PIN_A5,!flicker_hi);
	output_bit(PIN_A6,!flicker_hi);
	output_bit(PIN_A7,!flicker_hi);

	//PORT2
	output_bit(PIN_B0,!flicker_middle);
	output_bit(PIN_B1,!flicker_low);
	output_bit(PIN_B2,!flicker_middle);
	output_bit(PIN_B3,!flicker_low);
	output_bit(PIN_B4,!flicker_middle);
	output_bit(PIN_B5,!flicker_low);

	//PORT3
	output_bit(PIN_C0,!flicker_middle);
	output_bit(PIN_C1,!flicker_low);
	output_bit(PIN_C2,!flicker_middle);
	output_bit(PIN_C5,!flicker_low);

}

//VA|[g̃R}h
void serial_process1(){
	int tmp1 = 0;
	char *command;
	long long_param1;
	char *str_param1;
	char *str_param2;
	//int rdata = 0;
	int tmp_alarm_id = 0;

	if(get_command_c1[get_command_value_c1-1]==0xd){
		//R}hƃp[^𕪊
		command = strtok(get_command_c1,punctuate);
		//param1 = atoi(strtok(null,punctuate));
		//param1 = strtok(null,punctuate);

		fprintf(c1,"\r\n");

		//wv
		strcpy(compare_command_c1,"?\r");
		if(strcmp(command,compare_command_c1)==0){
			fprintf(c1,"ZT-****-SOFT Ver.0.90\r\n");
			fprintf(c1,"analog_value=%04ldmV\r\n",analog_value);
			fprintf(c1,"port1_ra1=%d\r\n",port1_ra1);
			//fprintf(c1,"0=SUN,1=mon,2=tue,3=wed,4=thu,5=fri,6=sat,7=all,8=week,9=off,\r\n");
			
		}

		//strcpy(compare_command_c1,"p");
		//if(strcmp(command,compare_command_c1)==0){
		//	//p[^̎擾
		//	//up,1v1param1ɓ
		//	fprintf(c1,"param1_u=%u ok.\r\n",param1);
		//}

		//SăNA
		for(tmp1=0;tmp1<80;++tmp1){
			get_command_c1[tmp1] = 0x0;
		}
		get_command_value_c1 = 0;

		//QƗp̃R}hNA
		for(tmp1=0;tmp1<10;++tmp1){
			compare_command_c1[tmp1] = 0x0;
		}
	}
}

